package gov.anl.aps.dm.common.exceptions;

import gov.anl.aps.dm.common.constants.DmStatus;

/**
 * Object not found exception.
 */
public class ObjectNotFound extends DmException {

    /**
     * Default constructor.
     */
    public ObjectNotFound() {
        super();
    }

    /**
     * Constructor using error message.
     *
     * @param message error message
     */
    public ObjectNotFound(String message) {
        super(message);
    }

    /**
     * Constructor using throwable object.
     *
     * @param throwable throwable object
     */
    public ObjectNotFound(Throwable throwable) {
        super(throwable);
    }

    /**
     * Constructor using error message and throwable object.
     *
     * @param message error message
     * @param throwable throwable object
     */
    public ObjectNotFound(String message, Throwable throwable) {
        super(message, throwable);
    }

    @Override
    public int getErrorCode() {
        return DmStatus.DM_OBJECT_NOT_FOUND;
    }    
}
