package gov.anl.aps.dm.portal.controllers;

import gov.anl.aps.dm.portal.model.beans.ExperimentRoleTypeDbFacade;
import gov.anl.aps.dm.portal.model.entities.ExperimentRoleType;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import org.apache.log4j.Logger;

@Named("experimentRoleTypeController")
@SessionScoped
public class ExperimentRoleTypeController extends DmEntityController<ExperimentRoleType, ExperimentRoleTypeDbFacade> {

    private static final Logger logger = Logger.getLogger(ExperimentRoleTypeController.class.getName());

    @EJB
    private ExperimentRoleTypeDbFacade experimentRoleTypeDbFacade;

    public ExperimentRoleTypeController() {
    }

    @Override
    protected ExperimentRoleTypeDbFacade getFacade() {
        return experimentRoleTypeDbFacade;
    }

    @Override
    protected ExperimentRoleType createEntityInstance() {
        return new ExperimentRoleType();
    }

    @Override
    public String getEntityTypeName() {
        return "experimentRoleType";
    }

    @Override
    public String getCurrentEntityInstanceName() {
        if (getCurrent() != null) {
            return getCurrent().getName();
        }
        return "";
    }

    @Override
    public ExperimentRoleType findById(Integer id) {
        return experimentRoleTypeDbFacade.findById(id);
    }
    
    @FacesConverter(forClass = ExperimentRoleType.class)
    public static class ExperimentRoleTypeControllerConverter implements Converter {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            ExperimentRoleTypeController controller = (ExperimentRoleTypeController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "experimentRoleTypeController");
            return controller.getEntity(getKey(value));
        }

        java.lang.Integer getKey(String value) {
            java.lang.Integer key;
            key = Integer.valueOf(value);
            return key;
        }

        String getStringKey(java.lang.Integer value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof ExperimentRoleType) {
                ExperimentRoleType o = (ExperimentRoleType) object;
                return getStringKey(o.getId());
            } else {
                throw new IllegalArgumentException("Object " + object + " is of type " + object.getClass().getName() + "; expected type: " + ExperimentRoleType.class.getName());
            }
        }

    }

}
