/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.beans;

import gov.anl.aps.dm.portal.model.entities.ExperimentType;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

/**
 *
 * @author sveseli
 */
@Stateless
public class ExperimentTypeDbFacade extends DmEntityDbFacade<ExperimentType>
{
    @PersistenceContext(unitName = "DmWebPortalPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public ExperimentTypeDbFacade() {
        super(ExperimentType.class);
    }

    public ExperimentType findByName(String name) {
        try {
            return (ExperimentType) em.createNamedQuery("ExperimentType.findByName")
                    .setParameter("name", name)
                    .getSingleResult();
        }
        catch (NoResultException ex) {
        }
        return null;
    }

    public ExperimentType findById(Integer id) {
        try {
            return (ExperimentType) em.createNamedQuery("ExperimentType.findById")
                    .setParameter("id", id)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }        
}
