/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.entities;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "experiment_role_type")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "ExperimentRoleType.findAll", query = "SELECT e FROM ExperimentRoleType e")
    , @NamedQuery(name = "ExperimentRoleType.findById", query = "SELECT e FROM ExperimentRoleType e WHERE e.id = :id")
    , @NamedQuery(name = "ExperimentRoleType.findByName", query = "SELECT e FROM ExperimentRoleType e WHERE e.name = :name")
    , @NamedQuery(name = "ExperimentRoleType.findByDescription", query = "SELECT e FROM ExperimentRoleType e WHERE e.description = :description")
})
public class ExperimentRoleType extends DmEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2147483647)
    private String name;
    @Size(max = 2147483647)
    private String description;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "experimentRoleType")
    private List<UserExperimentRole> userExperimentRoleList;

    public ExperimentRoleType() {
    }

    public ExperimentRoleType(Integer id) {
        this.id = id;
    }

    public ExperimentRoleType(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    @Override
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @XmlTransient
    public List<UserExperimentRole> getUserExperimentRoleList() {
        return userExperimentRoleList;
    }

    public void setUserExperimentRoleList(List<UserExperimentRole> userExperimentRoleList) {
        this.userExperimentRoleList = userExperimentRoleList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ExperimentRoleType)) {
            return false;
        }
        ExperimentRoleType other = (ExperimentRoleType) object;
        return !((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id)));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities2.ExperimentRoleType[ id=" + id + " ]";
    }
    
}
