/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.entities;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "experiment_station")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "ExperimentStation.findAll", query = "SELECT e FROM ExperimentStation e")
    , @NamedQuery(name = "ExperimentStation.findById", query = "SELECT e FROM ExperimentStation e WHERE e.id = :id")
    , @NamedQuery(name = "ExperimentStation.findByName", query = "SELECT e FROM ExperimentStation e WHERE e.name = :name")
    , @NamedQuery(name = "ExperimentStation.findByDescription", query = "SELECT e FROM ExperimentStation e WHERE e.description = :description")
})
public class ExperimentStation extends DmEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    private Integer id;
    @Basic(optional = false)
    @NotNull
    private String name;
    private String description;
    @JoinTable(name = "allowed_experiment_station_experiment_type", joinColumns = {
        @JoinColumn(name = "experiment_station_id", referencedColumnName = "id")}, inverseJoinColumns = {
        @JoinColumn(name = "experiment_type_id", referencedColumnName = "id")})
    @ManyToMany
    private List<ExperimentType> experimentTypeList;
    @OneToMany(mappedBy = "experimentStation")
    private List<UserSystemRole> userSystemRoleList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "experimentStation")
    private List<Experiment> experimentList;

    public ExperimentStation() {
    }

    public ExperimentStation(Integer id) {
        this.id = id;
    }

    public ExperimentStation(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    @Override
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @XmlTransient
    public List<ExperimentType> getExperimentTypeList() {
        return experimentTypeList;
    }

    public void setExperimentTypeList(List<ExperimentType> experimentTypeList) {
        this.experimentTypeList = experimentTypeList;
    }

    @XmlTransient
    public List<UserSystemRole> getUserSystemRoleList() {
        return userSystemRoleList;
    }

    public void setUserSystemRoleList(List<UserSystemRole> userSystemRoleList) {
        this.userSystemRoleList = userSystemRoleList;
    }

    @XmlTransient
    public List<Experiment> getExperimentList() {
        return experimentList;
    }

    public void setExperimentList(List<Experiment> experimentList) {
        this.experimentList = experimentList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ExperimentStation)) {
            return false;
        }
        ExperimentStation other = (ExperimentStation) object;
        return !((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id)));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities2.ExperimentStation[ id=" + id + " ]";
    }
    
}
