/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.entities;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "system_role_type")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "SystemRoleType.findAll", query = "SELECT s FROM SystemRoleType s")
    , @NamedQuery(name = "SystemRoleType.findById", query = "SELECT s FROM SystemRoleType s WHERE s.id = :id")
    , @NamedQuery(name = "SystemRoleType.findByName", query = "SELECT s FROM SystemRoleType s WHERE s.name = :name")
    , @NamedQuery(name = "SystemRoleType.findByDescription", query = "SELECT s FROM SystemRoleType s WHERE s.description = :description")
})
public class SystemRoleType extends DmEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2147483647)
    private String name;
    @Size(max = 2147483647)
    private String description;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "systemRoleType")
    private List<UserSystemRole> userSystemRoleList;

    public SystemRoleType() {
    }

    public SystemRoleType(Integer id) {
        this.id = id;
    }

    public SystemRoleType(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    @Override
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @XmlTransient
    public List<UserSystemRole> getUserSystemRoleList() {
        return userSystemRoleList;
    }

    public void setUserSystemRoleList(List<UserSystemRole> userSystemRoleList) {
        this.userSystemRoleList = userSystemRoleList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof SystemRoleType)) {
            return false;
        }
        SystemRoleType other = (SystemRoleType) object;
        return !((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id)));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities2.SystemRoleType[ id=" + id + " ]";
    }
    
}
