/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.entities;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "user_experiment_role")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "UserExperimentRole.findAll", query = "SELECT u FROM UserExperimentRole u")
    , @NamedQuery(name = "UserExperimentRole.findByUser", query = "SELECT u FROM UserExperimentRole u WHERE u.userExperimentRolePK.userId = :userId")
    , @NamedQuery(name = "UserExperimentRole.findByExperiment", query = "SELECT u FROM UserExperimentRole u WHERE u.userExperimentRolePK.experimentId = :experimentId")
    , @NamedQuery(name = "UserExperimentRole.findByRoleType", query = "SELECT u FROM UserExperimentRole u WHERE u.userExperimentRolePK.roleTypeId = :roleTypeId")
    , @NamedQuery(name = "UserExperimentRole.findByUserAndExperiment", query = "SELECT u FROM UserExperimentRole u WHERE u.userExperimentRolePK.userId = :userId AND u.userExperimentRolePK.experimentId = :experimentId")        
    , @NamedQuery(name = "UserExperimentRole.findByUserAndExperimentAndRoleType", query = "SELECT u FROM UserExperimentRole u WHERE u.userExperimentRolePK.userId = :userId AND u.userExperimentRolePK.experimentId = :experimentId AND u.userExperimentRolePK.roleTypeId = :roleTypeId")        
})
public class UserExperimentRole extends DmEntity {

    @EmbeddedId
    protected UserExperimentRolePK userExperimentRolePK;
    @JoinColumn(name = "experiment_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Experiment experiment;
    @JoinColumn(name = "role_type_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private ExperimentRoleType experimentRoleType;
    @JoinColumn(name = "user_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private UserInfo userInfo;

    public UserExperimentRole() {
    }

    public UserExperimentRole(UserExperimentRolePK userExperimentRolePK) {
        this.userExperimentRolePK = userExperimentRolePK;
    }

    public UserExperimentRole(int userId, int experimentId, int roleTypeId) {
        this.userExperimentRolePK = new UserExperimentRolePK(userId, experimentId, roleTypeId);
    }

    public UserExperimentRolePK getUserExperimentRolePK() {
        return userExperimentRolePK;
    }

    public void setUserExperimentRolePK(UserExperimentRolePK userExperimentRolePK) {
        this.userExperimentRolePK = userExperimentRolePK;
    }

    public Experiment getExperiment() {
        return experiment;
    }

    public void setExperiment(Experiment experiment) {
        this.experiment = experiment;
    }

    public ExperimentRoleType getExperimentRoleType() {
        return experimentRoleType;
    }

    public void setExperimentRoleType(ExperimentRoleType experimentRoleType) {
        this.experimentRoleType = experimentRoleType;
    }

    public UserInfo getUserInfo() {
        return userInfo;
    }

    public void setUserInfo(UserInfo userInfo) {
        this.userInfo = userInfo;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (userExperimentRolePK != null ? userExperimentRolePK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof UserExperimentRole)) {
            return false;
        }
        UserExperimentRole other = (UserExperimentRole) object;
        return !((this.userExperimentRolePK == null && other.userExperimentRolePK != null) || (this.userExperimentRolePK != null && !this.userExperimentRolePK.equals(other.userExperimentRolePK)));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities2.UserExperimentRole[ userExperimentRolePK=" + userExperimentRolePK + " ]";
    }
    
}
