/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.entities;

import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "user_info")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "UserInfo.findAll", query = "SELECT u FROM UserInfo u")
    , @NamedQuery(name = "UserInfo.findById", query = "SELECT u FROM UserInfo u WHERE u.id = :id")
    , @NamedQuery(name = "UserInfo.findByUsername", query = "SELECT u FROM UserInfo u WHERE u.username = :username")
    , @NamedQuery(name = "UserInfo.findByFirstName", query = "SELECT u FROM UserInfo u WHERE u.firstName = :firstName")
    , @NamedQuery(name = "UserInfo.findByLastName", query = "SELECT u FROM UserInfo u WHERE u.lastName = :lastName")
    , @NamedQuery(name = "UserInfo.findByMiddleName", query = "SELECT u FROM UserInfo u WHERE u.middleName = :middleName")
    , @NamedQuery(name = "UserInfo.findByEmail", query = "SELECT u FROM UserInfo u WHERE u.email = :email")
    , @NamedQuery(name = "UserInfo.findByBadge", query = "SELECT u FROM UserInfo u WHERE u.badge = :badge")
    , @NamedQuery(name = "UserInfo.findByGlobusUsername", query = "SELECT u FROM UserInfo u WHERE u.globusUsername = :globusUsername")
    , @NamedQuery(name = "UserInfo.findByDescription", query = "SELECT u FROM UserInfo u WHERE u.description = :description")
    , @NamedQuery(name = "UserInfo.findByPassword", query = "SELECT u FROM UserInfo u WHERE u.password = :password")
    , @NamedQuery(name = "UserInfo.findByIsLocalUser", query = "SELECT u FROM UserInfo u WHERE u.isLocalUser = :isLocalUser")
    , @NamedQuery(name = "UserInfo.findByLastUpdate", query = "SELECT u FROM UserInfo u WHERE u.lastUpdate = :lastUpdate")
})
public class UserInfo extends DmEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    private Integer id;
    @Basic(optional = false)
    @NotNull
    private String username;
    @Basic(optional = false)
    @NotNull
    @Column(name = "first_name")
    private String firstName;
    @Basic(optional = false)
    @NotNull
    @Column(name = "last_name")
    private String lastName;
    @Column(name = "middle_name")
    private String middleName;
    // @Pattern(regexp="[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?", message="Invalid email")//if the field contains email address consider using this annotation to enforce field validation
    private String email;
    private String badge;
    @Column(name = "globus_username")
    private String globusUsername;
    private String description;
    private String password;
    @Basic(optional = false)
    @NotNull
    @Column(name = "is_local_user")
    private boolean isLocalUser;
    @Column(name = "last_update")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastUpdate;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "userInfo")
    private List<UserExperimentRole> userExperimentRoleList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "userInfo")
    private List<UserSystemRole> userSystemRoleList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "userId")
    private List<UserSetting> userSettingList;

    public UserInfo() {
    }

    public UserInfo(Integer id) {
        this.id = id;
    }

    public UserInfo(Integer id, String username, String firstName, String lastName, boolean isLocalUser) {
        this.id = id;
        this.username = username;
        this.firstName = firstName;
        this.lastName = lastName;
        this.isLocalUser = isLocalUser;
    }

    @Override
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public String getMiddleName() {
        return middleName;
    }

    public void setMiddleName(String middleName) {
        this.middleName = middleName;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getBadge() {
        return badge;
    }

    public void setBadge(String badge) {
        this.badge = badge;
    }

    public String getGlobusUsername() {
        return globusUsername;
    }

    public void setGlobusUsername(String globusUsername) {
        this.globusUsername = globusUsername;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public boolean getIsLocalUser() {
        return isLocalUser;
    }

    public void setIsLocalUser(boolean isLocalUser) {
        this.isLocalUser = isLocalUser;
    }

    public boolean isLocalUser() {
        return isLocalUser;
    }
    
    public Date getLastUpdate() {
        return lastUpdate;
    }

    public void setLastUpdate(Date lastUpdate) {
        this.lastUpdate = lastUpdate;
    }

    @XmlTransient
    public List<UserExperimentRole> getUserExperimentRoleList() {
        return userExperimentRoleList;
    }

    public void setUserExperimentRoleList(List<UserExperimentRole> userExperimentRoleList) {
        this.userExperimentRoleList = userExperimentRoleList;
    }

    @XmlTransient
    public List<UserSystemRole> getUserSystemRoleList() {
        return userSystemRoleList;
    }

    public void setUserSystemRoleList(List<UserSystemRole> userSystemRoleList) {
        this.userSystemRoleList = userSystemRoleList;
    }

    @XmlTransient
    public List<UserSetting> getUserSettingList() {
        return userSettingList;
    }

    public void setUserSettingList(List<UserSetting> userSettingList) {
        this.userSettingList = userSettingList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof UserInfo)) {
            return false;
        }
        UserInfo other = (UserInfo) object;
        return !((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id)));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities2.UserInfo[ id=" + id + " ]";
    }
    
}
