#!/usr/bin/env python

from dm.aps_user_db.api.apsUserDbApiBase import ApsUserDbApiBase
from dm.aps_user_db.impl.apsUserInfoHandler import ApsUserInfoHandler

class ApsUserDbApi(ApsUserDbApiBase):
    """ APS User DB API class. """
    def __init__(self):
        ApsUserDbApiBase.__init__(self)
        self.userInfoHandler = ApsUserInfoHandler()

    @ApsUserDbApiBase.executeQuery
    def getApsUsers(self, **kwargs):
        session = kwargs['session']
        dbUsers = self.userInfoHandler.getApsUsers(session)
        return self.toDmObjectList(dbUsers)

    @ApsUserDbApiBase.executeQuery
    def getApsUserByBadgeNumber(self, badgeNumber, **kwargs):
        session = kwargs['session']
        dbUserInfo = self.userInfoHandler.getApsUserByBadgeNumber(session, badgeNumber)
        return dbUserInfo.getDmObject()

#######################################################################
# Testing.
if __name__ == '__main__':
    api = ApsUserDbApi()
    #users = api.getApsUsers()
    #for u in users:
    #    print u
    print api.getApsUserByBadgeNumber(225159)


