#!/usr/bin/env python

#
# Login route descriptor.
#

from dm.common.utility.configurationManager import ConfigurationManager
from dm.common.service.loginController import LoginController

class LoginRouteDescriptor:

    @classmethod
    def getRoutes(cls):
        contextRoot = ConfigurationManager.getInstance().getContextRoot()
        loginController = LoginController()

        routes = [

            # Login
            {
                'name'          : 'login',
                'path'          : '%s/login' % contextRoot,
                'controller'    : loginController,
                'action'        : 'login',
                'method'        : [ 'PUT', 'POST' ]
            },

        ]
       
        return routes


