#!/usr/bin/env python

from dm.daq_web_service.api.experimentRestApi import ExperimentRestApi
from daqWebServiceSessionCli import DaqWebServiceSessionCli

class GetProcessingPluginsCli(DaqWebServiceSessionCli):
    def __init__(self):
        DaqWebServiceSessionCli.__init__(self)

    def runCommand(self):
        self.parseArgs(usage="""
    dm-get-processing-plugins

Description:
    Retrieves list of known processing plugins.
        """)
        api = ExperimentRestApi(self.getLoginUsername(), self.getLoginPassword(), self.getServiceHost(), self.getServicePort(), self.getServiceProtocol())
        plugins = api.getProcessingPlugins()
        for plugin in plugins:
            print plugin.getDisplayString(self.getDisplayKeys(), self.getDisplayFormat())


#######################################################################
# Run command.
if __name__ == '__main__':
    cli = GetProcessingPluginsCli()
    cli.run()
